"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCompatEffect = void 0;
var react_1 = require("react");
var shared_1 = require("../shared");
var isArr = Array.isArray;
var isEqualDeps = function (target, source) {
    var arrA = isArr(target);
    var arrB = isArr(source);
    if (arrA !== arrB)
        return false;
    if (arrA) {
        if (target.length !== source.length)
            return false;
        return target.every(function (val, index) { return val === source[index]; });
    }
    return target === source;
};
var useCompatEffect = function (effect, deps) {
    var depsRef = (0, react_1.useRef)(null);
    var mountedRef = (0, react_1.useRef)(false);
    (0, react_1.useEffect)(function () {
        mountedRef.current = true;
        var dispose = effect();
        return function () {
            mountedRef.current = false;
            if (!isEqualDeps(depsRef.current, deps)) {
                if (dispose)
                    dispose();
                return;
            }
            (0, shared_1.immediate)(function () {
                if (mountedRef.current)
                    return;
                if (dispose)
                    dispose();
            });
        };
    }, deps);
    depsRef.current = deps;
};
exports.useCompatEffect = useCompatEffect;
//# sourceMappingURL=useCompatEffect.js.map